package cn.sunline.proxy.access.server;

package ..deTemp.1733470415911;

import akka.NotUsed;
import akka.actor.ActorRefFactory;
import akka.actor.ActorSystem;
import akka.http.javadsl.ConnectHttp;
import akka.http.javadsl.Http;
import akka.http.javadsl.model.HttpRequest;
import akka.http.javadsl.model.HttpResponse;
import akka.http.javadsl.server.AllDirectives;
import akka.http.javadsl.server.Route;
import akka.http.javadsl.unmarshalling.Unmarshaller;
import akka.stream.ActorMaterializer;
import akka.stream.Materializer;
import akka.stream.javadsl.Flow;
import cn.sunline.proxy.access.v7.SSunTuxedoClient;
import h2o.common.util.ioc.ObjectFactory;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.CompletionStage;
import java.util.concurrent.Executor;
import java.util.concurrent.Executors;

public class HttpServer extends AllDirectives {
  private static final int WORK_THREADPOOL_SIZE = 1000;
  
  public static void main(String[] args) throws Exception {
    int port = 9000;
    if (args.length == 1)
      port = Integer.parseInt(args[0]); 
    ActorSystem system = ActorSystem.create("PayPlat");
    Http http = Http.get(system);
    ActorMaterializer materializer = ActorMaterializer.create((ActorRefFactory)system);
    cn.sunline.proxy.access.server.HttpServer app = new cn.sunline.proxy.access.server.HttpServer();
    Flow<HttpRequest, HttpResponse, NotUsed> routeFlow = app.createRoute().flow(system, (Materializer)materializer);
    http.bindAndHandle(routeFlow, 
        ConnectHttp.toHost("0.0.0.0", port), (Materializer)materializer);
    System.out.println("Server online...");
  }
  
  private static final Executor executor = Executors.newFixedThreadPool(1000);
  
  private static final SSunTuxedoClient v7Client = (SSunTuxedoClient)ObjectFactory.get("v7Client", new Object[0]);
  
  private CompletionStage<String> proc(String req) {
    return CompletableFuture.supplyAsync(() -> v7Client.sendMsg(req), executor);
  }
  
  private Route createRoute() {
    return route(new Route[] { post(() -> pathPrefix("Proxy", ())) });
  }
}
